# Install webpacker
copy_file "#{__dir__}/config/webpacker.yml", Dir.pwd+"config/webpacker.yml"

puts "Copying webpack core config and loaders"
directory "#{__dir__}/config/webpack", Dir.pwd+"config/webpack"

puts "Copying .postcssrc.yml to app root directory"
copy_file "#{__dir__}/config/.postcssrc.yml", Dir.pwd+".postcssrc.yml"

puts "Copying .babelrc to app root directory"
copy_file "#{__dir__}/config/.babelrc", Dir.pwd+".babelrc"

puts "Creating javascript app source directory"
directory "#{__dir__}/javascript", Dir.pwd+"/app/javascript"

puts "Copying binstubs"
directory "#{__dir__}/bin", Dir.pwd+"/bin"

chmod "bin", 0755 & ~File.umask, verbose: false

if File.exists?(Dir.pwd+"/.gitignore")
  append_to_file Dir.pwd+"/.gitignore", <<-EOS
  /public/packs
  /public/packs-test
  /node_modules
EOS
end

puts "Installing all JavaScript dependencies"
run "yarn add @rails/webpacker"

puts "Installing dev server for live reloading"
run "yarn add --dev webpack-dev-server"

puts "Webpacker successfully installed 🎉 🍰"
