require "active_support/core_ext/module/attribute_accessors"
require "active_support/logger"
require "active_support/tagged_logging"

module Webpacker
  extend self

  def instance=(instance)
    @instance = instance
  end

  def instance
    @instance ||= Webpacker::Instance.new
  end

  delegate :logger, :logger=, :env, to: :instance
  delegate :config, :compiler, :manifest, :commands, :dev_server, to: :instance
  delegate :bootstrap, :clobber, :compile, to: :commands
end

require "webpacker-for-component/instance"
require "webpacker-for-component/configuration"
require "webpacker-for-component/manifest"
require "webpacker-for-component/compiler"
require "webpacker-for-component/commands"
require "webpacker-for-component/dev_server"

require "webpacker-for-component/railtie" if defined?(Rails)
